/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
 * 
 */
package jp.mosp.kintai.payroll.action;

import java.util.ArrayList;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.common.part.MosPCodePart;
import jp.mosp.common.utils.CsvUtil;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.StringUtil;
import jp.mosp.kintai.common.action.KintaiCommonAction;
import jp.mosp.kintai.common.dto.MKihonDto;
import jp.mosp.kintai.payroll.dto.KdPaidHolidayDto;
import jp.mosp.kintai.payroll.dto.MYukyuDto;
import jp.mosp.kintai.payroll.vo.PaidHolidayExportCardVo;

/**
 * @author nakamura
 *
 */
public class PaidHolidayExportCardAction extends KintaiCommonAction {
	
	// コマンド
	private static final String	CMD_SHOW	= "P1130";
	private static final String	CMD_EXPORT	= "P1131";
	

	/**
	 * コンストラクター
	 */
	public PaidHolidayExportCardAction() {
		super();
	}
	
	public void action() throws Exception {
		// VOの準備
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (CMD_SHOW.equals(cmd)) {
			// 表示
			show();
		} else if (CMD_EXPORT.equals(cmd)) {
			// エクスポート
			export();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new PaidHolidayExportCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// ユーザ情報の取得
		getInfo(user.getUserId());
		// プルダウンの設定
		PaidHolidayExportCardVo vo = (PaidHolidayExportCardVo)getVo();
		Date todayDate = DateUtil.getSystemDate();
		int todayYear = MospUtility.getYear(todayDate);
		final int year2010 = 2010;
		vo.aryPltSection = getSectionArrayAll();
		vo.aryPltYear = StringUtil.getYearArray(todayYear, 9, 1);
		vo.aryPltMonth = StringUtil.getMonthArray();
		vo.aryPltPaidHolidayTable = getPaidHolidayTableArray();
		vo.aryOldYear = StringUtil.getYearArray(year2010, 3, 0);
		if (todayYear - year2010 != 0) {
			vo.aryNewYear = StringUtil.getYearArray(todayYear, todayYear - year2010, 1);
		} else {
			vo.aryNewYear = StringUtil.getYearArray(todayYear, 0, 1);
		}
		vo.aryOldMonth = getOldMonthArray();
		vo.aryNewMonth = getNewMonthArray();
	}
	
	@Override
	protected void show() throws Exception {
		PaidHolidayExportCardVo vo = (PaidHolidayExportCardVo)getVo();
		// 初期値
		Date todayDate = DateUtil.getSystemDate();
		vo.setPltSection(userBasis.getSCode());
		// 開始年月日
		vo.setPltStartYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltStartMonth(String.valueOf(MospUtility.getMonth(todayDate)));
		// 終了年月日
		vo.setPltEndYear(String.valueOf(MospUtility.getYear(todayDate)));
		vo.setPltEndMonth(String.valueOf(MospUtility.getMonth(todayDate)));
		vo.setPltPaidHolidayTable(CommonConst.NAM_COMMON_FLAG_OFF);
		if (MosPCodePart.afterLegalReformDate(todayDate)) {
			vo.setPltPaidHolidayTable(CommonConst.NAM_COMMON_FLAG_ON);
		}
	}
	
	/**
	 * エクスポート
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void export() throws Exception {
		PaidHolidayExportCardVo vo = (PaidHolidayExportCardVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// 妥当性確認
		vo.validate();
		// 社員コードリスト
		List<String> kCodeList = new ArrayList<String>();
		// 開始年月日
		Date startDate = DateUtil.getFirstDateOfMonth(vo.getPltStartYear(), vo.getPltStartMonth());
		// 終了年月日
		Date endDate = DateUtil.getLastDateOfMonth(vo.getPltEndYear(), vo.getPltEndMonth());
		// 社員コードが入力されている場合
		if (StringUtil.isNotNull(vo.getTxtKCode())) {
			kCodeList.add(vo.getTxtKCode());
		} else {
			List<MKihonDto> mkihonList = part().human().getMKihonDao().findForSection(vo.getPltSection(),
					DateUtil.convDateToInteger(startDate), DateUtil.convDateToInteger(endDate));
			for (MKihonDto dto : mkihonList) {
				kCodeList.add(dto.getKCode());
			}
		}
		// 出力ファイル名
		StringBuffer fileName = new StringBuffer();
		fileName.append("PaidHoliday");
		fileName.append(CommonConst.FILE_NAME_SEPARATOR);
		if (StringUtil.isNotNull(vo.getTxtKCode())) {
			fileName.append(vo.getTxtKCode());
			fileName.append(CommonConst.FILE_NAME_SEPARATOR);
		} else {
			fileName.append(vo.getPltSection());
			fileName.append(CommonConst.FILE_NAME_SEPARATOR);
		}
		fileName.append(DateUtil.convDateToString(startDate));
		fileName.append(CommonConst.FILE_NAME_SEPARATOR);
		fileName.append(DateUtil.convDateToString(endDate));
		fileName.append(CommonConst.FILE_COMMON_CSV);
		request.setAttribute(MospConst.ATT_FILE_NAME, fileName.toString());
		// 出力ファイルオブジェクト
		request.setAttribute(MospConst.ATT_FILE_OBJECT, makePaidHolidayExportData(kCodeList, startDate, endDate));
		// 処理シーケンスを発行しない。
		setNeedProcSeq(false);
	}
	
	/**
	 * エクスポートデータ生成
	 * @param kCodeList		対象社員コードリスト
	 * @param startDate		開始年月日
	 * @param endDate		終了年月日
	 * @return	有給休暇データ（CSV）
	 * @throws Exception 	例外処理が発生した場合
	 */
	private StringBuffer makePaidHolidayExportData(List<String> kCodeList, Date startDate, Date endDate)
			throws Exception {
		PaidHolidayExportCardVo vo = (PaidHolidayExportCardVo)getVo();
		// 帳票作成準備
		StringBuffer sb = new StringBuffer();
		if (CommonConst.NAM_COMMON_FLAG_OFF.equals(vo.getPltPaidHolidayTable())) {
			// ヘッダー情報設定
			sb.append(CsvUtil.toCsvLine(part().paidHoliday().getOldPaidHolidayCsvHeader()));
			// データ追記
			for (String kCode : kCodeList) {
				List<MYukyuDto> yukyuList = part().paidHoliday().getOldYukyuInfoList(kCode, startDate, endDate);
				for (MYukyuDto dto : yukyuList) {
					sb.append(CsvUtil.toCsvLine(toCsvOldDataArray(dto)));
				}
			}
		} else if (CommonConst.NAM_COMMON_FLAG_ON.equals(vo.getPltPaidHolidayTable())) {
			// ヘッダー情報設定
			sb.append(CsvUtil.toCsvLine(part().paidHoliday().getNewPaidHolidayCsvHeader()));
			// データ追記
			for (String kCode : kCodeList) {
				List<KdPaidHolidayDto> paidHolidayList = part().paidHoliday().getPaidHolidayInfoList(kCode, startDate,
						endDate);
				for (KdPaidHolidayDto dto : paidHolidayList) {
					sb.append(CsvUtil.toCsvLine(toCsvNewDataArray(dto)));
				}
			}
		}
		return sb;
	}
	
	/**
	 * 新旧有給休暇テーブル選択プルダウン
	 * @return		新旧有給休暇テーブル
	 */
	private String[][] getPaidHolidayTableArray() {
		return StringUtil.getFlagArray("〜2010年3月まで", "2010年4月〜");
	}
	
	/**
	 * 旧有給休暇テーブル選択時月プルダウン
	 * @return		1〜3月プルダウン
	 */
	private String[][] getOldMonthArray() {
		String[][] arrayOldMonth = new String[3][2];
		for (int i = 0; i < 3; i++) {
			arrayOldMonth[i][0] = String.valueOf(i + 1);
			arrayOldMonth[i][1] = String.valueOf(i + 1);
		}
		return arrayOldMonth;
	}
	
	/**
	 * 新有給休暇テーブル選択時月プルダウン
	 * @return		4〜12月プルダウン
	 */
	private String[][] getNewMonthArray() {
		String[][] arrayNewMonth = new String[9][2];
		for (int i = 3; i < 12; i++) {
			arrayNewMonth[i - 3][0] = String.valueOf(i + 1);
			arrayNewMonth[i - 3][1] = String.valueOf(i + 1);
		}
		return arrayNewMonth;
	}
	
	/**
	 * CSVファイル用文字列変換
	 * @param dto	対象有給休暇情報DTO
	 * @return	CSVファイル用配列
	 */
	public static String[] toCsvOldDataArray(MYukyuDto dto) {
		List<String> dataList = new LinkedList<String>();
		// 社員コード
		dataList.add(dto.getKCode());
		// 給与計算年月日
		dataList.add(String.valueOf(dto.getKyuyoYMD()));
		// 前月残数（当年）
		dataList.add(String.valueOf(dto.getZZanT()));
		// 前月残数（前年）
		dataList.add(String.valueOf(dto.getZZanZ()));
		// 当月使用
		dataList.add(String.valueOf(dto.getSyoka()));
		// 当月取得
		dataList.add(String.valueOf(dto.getSyutoku()));
		// 当月廃棄
		dataList.add(String.valueOf(dto.getHaiki()));
		// 当月残数（当年）
		dataList.add(String.valueOf(dto.getTZanT()));
		// 当月残数（前年）
		dataList.add(String.valueOf(dto.getTZanZ()));
		// 登録日
		//dataList.add(DateUtil.getDateTime(dto.get));
		// 登録者
		//dataList.add(dto.getInsertUser());
		// 更新日
		//dataList.add(DateUtil.getDateTime(dto.getUpdateDate()));
		// 更新者
		//dataList.add(dto.getInsertUser());
		return StringUtil.listToArray(dataList);
	}
	
	/**
	 * CSVファイル用文字列変換
	 * @param dto	対象有給休暇情報DTO
	 * @return	CSVファイル用配列
	 */
	public static String[] toCsvNewDataArray(KdPaidHolidayDto dto) {
		List<String> dataList = new LinkedList<String>();
		// 有休ID
		dataList.add(String.valueOf(dto.getPaidId()));
		// 社員コード
		dataList.add(dto.getKCode());
		// 処理コード
		dataList.add(dto.getProcessType());
		// 処理日
		dataList.add(DateUtil.convDateFormattedByHyphen(dto.getProcessDate()));
		// 前年度残日数
		dataList.add(String.valueOf(dto.getLastRemainDays()));
		// 前年度残時間
		dataList.add(String.valueOf(dto.getLastRemainHour()));
		// 今年度残日数
		dataList.add(String.valueOf(dto.getRemainDays()));
		// 今年度残時間
		dataList.add(String.valueOf(dto.getRemainHour()));
		// 時間単位取得可能日数
		dataList.add(String.valueOf(dto.getPossible()));
		// 削除フラグ
		dataList.add(String.valueOf(dto.getDeleteFlag()));
		// 登録日
		dataList.add(DateUtil.getDateTime(dto.getInsertDate()));
		// 登録者
		dataList.add(dto.getInsertUser());
		// 更新日
		dataList.add(DateUtil.getDateTime(dto.getUpdateDate()));
		// 更新者
		dataList.add(dto.getInsertUser());
		return StringUtil.listToArray(dataList);
	}
	
}
